using CoreLibrary.Manageurs;
using CoreLibrary.Persistance;
using CoreLibrary.Regles;
using CoreLibrary;
using System.Diagnostics.CodeAnalysis;
using CoreLibrary.Joueurs;
using Persistance.Persistance;

namespace ConsoleApp
{
    /// <summary>
    /// Permet de jouer une partie de mastermind, avec les rgles classqiues
    /// (2 joueurs, 12 tours, un code  code couleurs parmi 6) 
    /// </summary>
    [ExcludeFromCodeCoverage]
    public static class Program
    {
        public static Manageur Manageur { get; private set; } = new Manageur(new PersistanceJson());

        public static void Main()
        {
            Utils.DessinerTitre();

            Partie maPartie = Manageur.NouvellePartie(new ReglesClassiques());

            maPartie.PartieDemanderJoueur += Evenements.DemanderNom;
            maPartie.PartieDebutPartie += Evenements.CommencerLaPartie;
            maPartie.PartieNouveauTour += Evenements.NouveauTour;
            maPartie.PartiePasserLaMain += Evenements.AjouterCode;
            maPartie.PartiePartieTerminee += Evenements.PartieTerminee;

            maPartie.Jouer();
        }
    }
}

